%ifarch aarch64 ppc64le riscv64 x86_64
%global native_compiler 1
%global natdynlink 1
%else
%global native_compiler 0
%global natdynlink 0
%endif

%global test_arches aarch64 ppc64le riscv64 x86_64

Summary:        OCaml compiler and programming environment
Name:           ocaml
Version:        5.0.0
Release:        3%{?dist}

URL:            http://www.ocaml.org
License:        QPL and (LGPLv2+ with exceptions)
Source0:        https://github.com/ocaml/ocaml/archive/%{version}.tar.gz

Patch3000:      0001-increment-version-number-after-tagging-5.0.0.patch
Patch3001:      0002-Merge-pull-request-11814-from-gasche-clarify-DLS.new.patch
Patch3002:      0003-Add-KC-Sivaramakrishnan-as-author.patch
Patch3003:      0004-removed-set-but-unused-variables-in-yacc-reader.c-11.patch
Patch3004:      0005-Merge-pull-request-11860-from-Octachron-index_for_st.patch
Patch3005:      0006-Allow-installing-in-folder-with-space-in-name-11590.patch
Patch3006:      0007-Detect-unused-Makefile-variables-in-workflow.patch
Patch3007:      0008-Fix-incorrect-variable-from-runtime-Makefile-merge.patch
Patch3008:      0009-Provide-a-default-for-OCAMLDEPFLAGS.patch
Patch3009:      0010-Report-all-post-build-failures.patch
Patch3010:      0011-Finish-off-removal-of-FORCE_INSTRUMENTED_RUNTIME.patch
Patch3011:      0012-suppress-spurious-alert-when-compiling-stdlib-docume.patch
Patch3012:      0013-Merge-pull-request-12285-from-smorimoto-update-depre.patch
Patch3013:      0014-Merge-pull-request-12286-from-smorimoto-replace-set-.patch
Patch3014:      0015-Don-t-add-rpaths-to-libraries.patch
Patch3015:      0016-configure-Allow-user-defined-C-compiler-flags.patch
Patch3016:      0017-Fix-skiplist-test-failure-12346.patch

BuildRequires:  make gcc autoconf binutils-devel perl-interpreter git
BuildRequires:  ncurses-devel gdbm-devel gawk util-linux chrpath

Requires:       gcc
Requires:       system-rpm-config
Requires:       ocaml-runtime = %{version}-%{release}

Provides:       bundled(md5-plumb)
Provides:       ocaml(compiler) = %{version}

%global __ocaml_requires_opts -c -f '%{buildroot}%{_bindir}/ocamlrun %{buildroot}%{_bindir}/ocamlobjinfo.byte'
%global __ocaml_provides_opts -f '%{buildroot}%{_bindir}/ocamlrun %{buildroot}%{_bindir}/ocamlobjinfo.byte'


%description
OCaml is a high-level, strongly-typed, functional and object-oriented
programming language from the ML family of languages.

%package runtime
Summary:        OCaml runtime environment
Requires:       util-linux
Provides:       ocaml(runtime) = %{version}

%description runtime
This package contains the runtime environment needed to run OCaml
bytecode.


%package source
Summary:        Source code for OCaml libraries
Requires:       ocaml = %{version}-%{release}

%description source
Source code for OCaml libraries.


%package ocamldoc
Summary:        Documentation generator for OCaml
Requires:       ocaml = %{version}-%{release}
Provides:	ocamldoc

%description ocamldoc
Documentation generator for OCaml.


%package docs
Summary:        Documentation for OCaml
Requires:       ocaml = %{version}-%{release}


%description docs
This package contains man pages.


%package compiler-libs
Summary:        Compiler libraries for OCaml
Requires:       ocaml = %{version}-%{release}


%description compiler-libs
This package contains some modules used internally by the OCaml
compilers, useful for the development of some OCaml applications.
Note that this exposes internal details of the OCaml compiler which
may not be portable between versions.


%prep
%autosetup -p1 -Sgit

%ifarch loongarch64
cp /usr/lib/rpm/OpenCloudOS/config.guess ./build-aux/
cp /usr/lib/rpm/OpenCloudOS/config.sub ./build-aux/
%endif

%build
autoconf --force

sed -i '/ld_opts/s|\[\]|["%{build_ldflags}"]|' tools/ocamlmklib.ml

./configure \
    --prefix=%{_prefix} \
    --sysconfdir=%{_sysconfdir} \
    --mandir=%{_mandir} \
    --libdir=%{_libdir}/ocaml \
    --enable-flambda \
%if %{native_compiler}
    --enable-native-compiler \
    --enable-native-toplevel \
%else
    --disable-native-compiler \
    --disable-native-toplevel \
%endif
%ifarch x86_64
%if 0%{?_include_frame_pointers}
    --enable-frame-pointers \
%endif
%endif
    OC_CFLAGS='%{build_cflags}' \
    OC_LDFLAGS='%{build_ldflags}' \
    %{nil}
%make_build world
%if %{native_compiler}
%make_build opt
%make_build opt.opt
%endif

%install
%make_install
perl -pi -e "s|^%{buildroot}||" %{buildroot}%{_libdir}/ocaml/ld.conf

chrpath --delete %{buildroot}%{_libdir}/ocaml/stublibs/*.so
find %{buildroot} -name .ignore -delete
rm -f %{buildroot}%{_libdir}/ocaml/eventlog_metadata

rm -f %{buildroot}%{_defaultdocdir}/%{name}/Changes
rm -f %{buildroot}%{_defaultdocdir}/%{name}/LICENSE
rm -f %{buildroot}%{_defaultdocdir}/%{name}/README*

%check
%ifarch %{ocaml_native_compiler}
echo 'print_endline "hello, world"' > hello.ml
./ocamlopt.opt -verbose -I stdlib hello.ml -o hello ||:
%endif

%ifarch %{test_arches}
cd testsuite
make -j1 all ||:
%endif

%files
%license LICENSE
%{_bindir}/ocaml
%{_bindir}/ocamlcmt
%{_bindir}/ocamldebug
%{_bindir}/ocamlyacc
%{_bindir}/ocamlc
%{_bindir}/ocamlcp
%{_bindir}/ocamldep
%{_bindir}/ocamllex
%{_bindir}/ocamlmklib
%{_bindir}/ocamlmktop
%{_bindir}/ocamlobjinfo
%{_bindir}/ocamloptp
%{_bindir}/ocamlprof
%{_bindir}/ocamlc.byte
%{_bindir}/ocamlcp.byte
%{_bindir}/ocamldep.byte
%{_bindir}/ocamllex.byte
%{_bindir}/ocamlmklib.byte
%{_bindir}/ocamlmktop.byte
%{_bindir}/ocamlobjinfo.byte
%{_bindir}/ocamloptp.byte
%{_bindir}/ocamlprof.byte

%if %{native_compiler}
%{_bindir}/ocamlc.opt
%{_bindir}/ocamlcp.opt
%{_bindir}/ocamldep.opt
%{_bindir}/ocamllex.opt
%{_bindir}/ocamlmklib.opt
%{_bindir}/ocamlmktop.opt
%{_bindir}/ocamlobjinfo.opt
%{_bindir}/ocamloptp.opt
%{_bindir}/ocamlprof.opt
%endif

%if %{native_compiler}
%{_bindir}/ocamlnat
%{_bindir}/ocamlopt
%{_bindir}/ocamlopt.byte
%{_bindir}/ocamlopt.opt
%endif

%{_libdir}/ocaml/camlheader
%{_libdir}/ocaml/camlheader_ur
%{_libdir}/ocaml/expunge
%{_libdir}/ocaml/ld.conf
%{_libdir}/ocaml/Makefile.config

%{_libdir}/ocaml/*.a
%if %{native_compiler}
%{_libdir}/ocaml/*.cmxa
%{_libdir}/ocaml/*.cmx
%{_libdir}/ocaml/*.o
%{_libdir}/ocaml/libasmrun_shared.so
%endif
%{_libdir}/ocaml/*.mli
%{_libdir}/ocaml/sys.ml.in
%{_libdir}/ocaml/libcamlrun_shared.so

%{_libdir}/ocaml/{dynlink,runtime_events,str,threads,unix}/*.mli
%if %{native_compiler}
%{_libdir}/ocaml/{dynlink,runtime_events,str,threads,unix}/*.a
%{_libdir}/ocaml/{dynlink,runtime_events,str,threads,unix}/*.cmxa
%{_libdir}/ocaml/{dynlink,profiling,runtime_events,str,threads,unix}/*.cmx
%{_libdir}/ocaml/profiling/*.o
%endif
%if %{natdynlink}
%{_libdir}/ocaml/{runtime_events,str,unix}/*.cmxs
%endif
%{_libdir}/ocaml/caml


%files runtime
%license LICENSE
%doc README* Changes
%{_bindir}/ocamlrun
%{_bindir}/ocamlrund
%{_bindir}/ocamlruni
%dir %{_libdir}/ocaml
%{_libdir}/ocaml/*.cmo
%{_libdir}/ocaml/*.cmi
%{_libdir}/ocaml/*.cma
%{_libdir}/ocaml/camlheaderd
%{_libdir}/ocaml/camlheaderi
%{_libdir}/ocaml/stublibs
%dir %{_libdir}/ocaml/dynlink
%{_libdir}/ocaml/dynlink/META
%{_libdir}/ocaml/dynlink/*.cmi
%{_libdir}/ocaml/dynlink/*.cma
%dir %{_libdir}/ocaml/ocamlmktop
%{_libdir}/ocaml/ocamlmktop/*.cmo
%{_libdir}/ocaml/ocamlmktop/*.cmi
%dir %{_libdir}/ocaml/profiling
%{_libdir}/ocaml/profiling/*.cmo
%{_libdir}/ocaml/profiling/*.cmi
%dir %{_libdir}/ocaml/runtime_events
%{_libdir}/ocaml/runtime_events/META
%{_libdir}/ocaml/runtime_events/*.cmi
%{_libdir}/ocaml/runtime_events/*.cma
%{_libdir}/ocaml/stdlib
%dir %{_libdir}/ocaml/str
%{_libdir}/ocaml/str/META
%{_libdir}/ocaml/str/*.cmi
%{_libdir}/ocaml/str/*.cma
%dir %{_libdir}/ocaml/threads
%{_libdir}/ocaml/threads/META
%{_libdir}/ocaml/threads/*.cmi
%{_libdir}/ocaml/threads/*.cma
%dir %{_libdir}/ocaml/unix
%{_libdir}/ocaml/unix/META
%{_libdir}/ocaml/unix/*.cmi
%{_libdir}/ocaml/unix/*.cma


%files source
%license LICENSE
%{_libdir}/ocaml/*.ml
%{_libdir}/ocaml/*.cmt*
%{_libdir}/ocaml/*/*.cmt*


%files ocamldoc
%license LICENSE
%doc ocamldoc/Changes.txt
%{_bindir}/ocamldoc*
%{_libdir}/ocaml/ocamldoc


%files docs
%{_mandir}/man1/*
%{_mandir}/man3/*


%files compiler-libs
%license LICENSE
%{_libdir}/ocaml/compiler-libs


%changelog
* Mon May 20 2024 Huang Yang <huangyang@loongson.cn> - 5.0.0-3
- [Type] other
- [DESC] update config.guess and config.sub on loongarch

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.0.0-2
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Aug 1 2023 Shuo Wang <abushwang@tencent.com> - 5.0.0-1
- update to 5.0.0

* Fri May 05 2023 cunshunxia <cunshunxia@tencent.com> - 4.13.1-4
- remove unused files.

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.13.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.13.1-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Mar 09 2023 cunshunxia <cunshunxia@tencent.com> - 4.13.1-1
- initial build
